// Copyright (c) Strange Loop Games. All rights reserved.
// See LICENSE file in the project root for full license information.
// <auto-generated />

namespace Eco.Mods.TechTree
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using Eco.Gameplay.Blocks;
    using Eco.Gameplay.Components;
    using Eco.Gameplay.DynamicValues;
    using Eco.Gameplay.Items;
    using Eco.Gameplay.Objects;
    using Eco.Gameplay.Players;
    using Eco.Gameplay.Skills;
    using Eco.Gameplay.Systems;
    using Eco.Gameplay.Systems.TextLinks;
    using Eco.Core.Items;
    using Eco.Shared.Localization;
    using Eco.Shared.Serialization;
    using Eco.Shared.Utils;
    using Eco.World;
    using Eco.World.Blocks;
    using Eco.Gameplay.Pipes;

    /// <summary>Auto-generated class. Don't modify it! All your changes will be wiped with next update! Use Mods* partial methods instead for customization.</summary>
    [RequiresSkill(typeof(FarmingSkill), 1)]      
    public partial class CompostBlock1 :
        RecipeFamily
    {
        public CompostBlock1()
        {
            this.Recipes = new List<Recipe>
            {
                new Recipe(
                    "Compost",
                    Localizer.DoStr("Compost"),
                    new IngredientElement[]
                    {
                    new IngredientElement("Vegetable", 12, typeof(CampfireCookingSkill), typeof(CampfireCookingLavishResourcesTalent)),   
                    },
                    new CraftingElement[]
                    {
                    new CraftingElement<CompostItem>(),  
					new CraftingElement<GarbageItem>(2),  
                    }
                )
            };
            this.LaborInCalories = CreateLaborInCaloriesValue(20, typeof(FarmingSkill)); 
            this.ExperienceOnCraft = 1;  
            this.CraftMinutes = CreateCraftTimeValue(typeof(CompostBlock1), 0.5f, typeof(FarmingSkill), typeof(FarmingFocusedSpeedTalent), typeof(FarmingParallelSpeedTalent));     
            this.ModsPreInitialize();
            this.Initialize(Localizer.DoStr("Compost"), typeof(CompostBlock1));
            this.ModsPostInitialize();

            CraftingComponent.AddRecipe(typeof(FarmersTableObject), this);
        }

        /// <summary>Hook for mods to customize RecipeFamily before initialization. You can change recipes, xp, labor, time here.</summary>
        partial void ModsPreInitialize();
        /// <summary>Hook for mods to customize RecipeFamily after initialization, but before registration. You can change skill requirements here.</summary>
        partial void ModsPostInitialize();
    }

    [Serialized]
    [Solid, Wall, Constructed,BuildRoomMaterialOption]
    [BlockTier(2)]                                          
    [RequiresSkill(typeof(FarmingSkill), 1)]      
    public partial class CompostBlock1Block :
        Block            
        , IRepresentsItem   
    {
        public Type RepresentedItemType { get { return typeof(CompostBlock1Item); } }  
    }

    [Serialized]
    [LocDisplayName("Compost")]
    [MaxStackSize(20000)]                           
    [Weight(1)]      
    [Ecopedia("Blocks", "Building Materials", createAsSubPage: true, display: InPageTooltip.DynamicTooltip)]                    
    [Currency][Tag("Currency")]                              
    [Tag("Constructable", 1)]                         
    [Tier(2)]                                      
    public partial class CompostBlock1Item :
    BlockItem<CompostBlock1Block>
    {
        public override LocString DisplayDescription { get { return Localizer.DoStr("Durable building material made from fired blocks and mortar."); } }

        public override bool CanStickToWalls { get { return false; } }  

        private static Type[] blockTypes = new Type[] {
        typeof(CompostBlock1Stacked1Block),
        typeof(CompostBlock1Stacked2Block),
        typeof(CompostBlock1Stacked3Block),
            typeof(CompostBlock1Stacked4Block)
        };
        public override Type[] BlockTypes { get { return blockTypes; } }
    }

    [Serialized, Solid] public class CompostBlock1Stacked1Block : PickupableBlock { }
    [Serialized, Solid] public class CompostBlock1Stacked2Block : PickupableBlock { }
    [Serialized, Solid] public class CompostBlock1Stacked3Block : PickupableBlock { }
    [Serialized, Solid,Wall] public class CompostBlock1Stacked4Block : PickupableBlock { } //Only a wall if it's all 4 CompostBlock1
}
